part of example.basic_auth.server;

/// Collection of routes students can also access
@Api(path: '/book')
@Wrap(const [#sessionInterceptor, #userAuthoriser])
class StudentRoutes {
  @Get(path: '/all')
  Response<String> getAllBooks(Context ctx) {
    List<Map> ret = _books.values.map((Book book) => book.toMap()).toList();

    Response<String> resp = new Response<String>(JSON.encode(ret));
    resp.cookies.add(new Cookie('sample-cookie', 'sample-cookie-value'));
    return resp;
  }

  @Get(path: '/:id', headers: const {'sample-header': 'sample-value'})
  String getBook(Context ctx) {
    String id = ctx.pathParams.get('id');
    Book book = _books[id];
    return book.toJson();
  }

  SessionInterceptor sessionInterceptor(Context ctx) =>
      new SessionInterceptor(sessionManager());

  UserAuthoriser userAuthoriser(Context ctx) => new UserAuthoriser(kModelManager);
}
